/* Pseudo device library routines Copyright (C), Lawrence Foard, 1992 
 * May be used under the gnu library license
 */
#include <stdio.h>
#include <fcntl.h>
#include "pseudo_lib.h"

typedef struct diskfile DISKFILE;

struct diskfile
 {
  int fd;
  int size;
  PSEUDO *pseudo;
 };

static read_data(DISKFILE *disk,int pos,char *buf,int count)
 {
  int ncount;
  lseek(disk->fd,pos,0);
  if ((ncount=read(disk->fd,buf,count))==-1)
   ncount=0;
  /* zero fill blocks past end of file */
  while(ncount<count)
   buf[ncount++]=0;
  return(count);
 }

static write_data(DISKFILE *disk,int pos,char *buf,int count)
 {
  int ncount;
  lseek(disk->fd,pos,0);
  if ((ncount=write(disk->fd,buf,count))==-1)
   ncount=0;
  return(ncount);
 }

main(int argc,char *argv[])
 {
  DISKFILE diskfile;
  if (!argv[1] || !argv[2])
   {
    fprintf(stderr,"Usage: device_name file_name [size in K]\n");
    exit(1);
   }
  if (!(diskfile.pseudo=open_pseudo(argv[1])))
   {
    perror(argv[1]);
    exit(1);
   }
  if ( (-1==(diskfile.fd=open(argv[2],O_RDWR))) && (-1==(diskfile.fd=open(argv[2],O_RDWR | O_CREAT,0777))))
   {
    perror(argv[2]);
    exit(1);
   }
  if (argv[3])
   diskfile.size=atoi(argv[3])*1024;
  else
   diskfile.size=lseek(diskfile.fd,0,2);
  size_pseudo(diskfile.pseudo,diskfile.size);
  run_pseudo(diskfile.pseudo,read_data,write_data,&diskfile);
 }
 