/* Pseudo block device code, copyright (C), 1992, Lawrence Foard 
 * lfoard@turing.org, entropy@world.std.com
 * This code is under the GNU License
 */

#define PSIO_CLOSE  0x3602 /* ask the kernel to negotiate shutdown with device */

/* command header */
struct pc_header
 {
  int size; /* size of command including "size word" */
  int command; /* command code */
  int serial;  /* command serial # */
 };
 
/* commands */
#define PC_INDIAN 0  /* tells the indianness (sp?) of the sender (: guess why its command # 0 :) */
 /* data: 4 bytes for example "1234" or "2134" etc. */
#define PC_UNREC 1 /* I don't recognize that command */
struct pc_unrec
 {
  struct pc_header header;
  struct pc_header bad_header;
 };
#define PC_WRITE 2 /* write data */
struct pc_write
 {
  struct pc_header header;
  int location;
  int size;
  /* data follows structure */
 };
#define PC_W_REPLY 3 /* reply to write request */
struct pc_w_reply
 {
  struct pc_header header;
  struct pc_write write_req; /* the write request without data */
  int actually_wrote; /* bytes actually written */
 };
#define PC_READ 4 /* read data */
struct pc_read
 {
  struct pc_header header;
  int location;
  int size;
 };
#define PC_R_REPLY 5 /* reply to read request */
struct pc_r_reply
 {
  struct pc_header header;
  struct pc_read read_req; /* the read request without data */
  int actually_read; /* bytes actually read */
 };
#define PC_CLOSE 6 /* request a "nice" shutdown, may not request anything after this */
struct pc_close
 {
  struct pc_header header;
 };
#define PC_R_CLOSE 7 /* close accepted, ok to shutdown connection */
struct pc_r_close
 {
  struct pc_header header;
 };
#define PC_SIZE 8 /* tell the size of this device */
struct pc_size
 {
  struct pc_header header;
  int size;
 };
