/* Pseudo device library routines Copyright (C), Lawrence Foard, 1992 
 * May be used under the gnu library license
 */
#include <stdio.h>
#include <fcntl.h>
#include "pseudo_lib.h"

typedef struct ramdisk RAMDISK;

struct ramdisk
 {
  PSEUDO *pseudo;
  char *ram;
  int size;
 };

static read_data(RAMDISK *ramdisk,int pos,char *buf,int count)
 {
  memcpy(buf,ramdisk->ram+pos,count);
  return(count);
 }

static write_data(RAMDISK *ramdisk,int pos,char *buf,int count)
 {
  memcpy(ramdisk->ram+pos,buf,count);
  return(count);
 }

main(int argc,char *argv[])
 {
  RAMDISK ramdisk;
  if (!argv[1] || !argv[2])
   {
    fprintf(stderr,"Usage: [device name] [size in K]\n");
    exit(1);
   }
  if (!(ramdisk.pseudo=open_pseudo(argv[1])))
   {
    perror(argv[1]);
    exit(1);
   }
  ramdisk.size=atoi(argv[2])*1024;
  ramdisk.ram=(char *)sbrk(ramdisk.size);
  size_pseudo(ramdisk.pseudo,ramdisk.size);
  run_pseudo(ramdisk.pseudo,read_data,write_data,&ramdisk);
 }
 